Program (icon:"hag\icons\window.ico")
   Uses
       cobra2D,
       keyset,
       vm_pacman,
       vmAsm_pacman,
       pacmanHapi

Var   
    s: String
  
    asmResultString: ^asmResultStrings
    vmResultString: ^vmResultStrings
    myScript: ^vmScripts
    funcMain: ^vmFuncs
    funcUpdate: ^vmFuncs
   
    mf: Element
    mfAsm: Element

Procedure Main()
Begin

    SetAppName("Pacman VM example")
    OpenScreen(640, 480, 32, FALSE, COB_SHOWBORDER+COB_SHOWCLOSE)
    Randomize(Millisecs)
   
    // Load + assemble asm script
    If Not FileExists("pacman.asm") then exit
    If FileExists("pacman.xmb") then DeleteFile("pacman.xmb")
    mf = CreateMemFile()
    LoadToMemFile(mf, "pacman.asm")
    mfAsm = Asm_Assemble(mf)
    SaveMemFile(mfAsm, "pacman.xmb")
    Closefile(mf)
    Closefile(mfAsm)

    If asmErrors > 0 then
        s = ""
        Loop asmResultString through asmResultStringList
            s = s + asmResultString.s + Chr(10)
        EndLoop
        Asm_ClearMessages()
        MessageBox(s, "vmAsm Errors")
        exit
    Endif
    
    // Load an assembled xmb
    mf = CreateMemFile()
    LoadToMemFile(mf, "pacman.xmb")
    myScript = Vm_Load(mf)
    Closefile(mf)
    
    // Start
    pacmanInit()
    funcMain = Vm_GetFunction(myScript, "Main")
    funcUpdate = Vm_GetFunction(myScript, "Update")
    Vm_RunFunction(myScript, funcMain)
    
    // Mainloop
    FlushKeys()
    ResetFramer()
    While (KeyHits(VK_ESCAPE) < 1)
        SyncFramer()
    
        Vm_RunFunction(myScript, funcUpdate)
              
        Flip
        Pause(1)
        
        cfps = CalcFps(mls, Millisecs)
        RenderFps(cfps)
    Wend
    
    // Vm Errors
    If vmErrors > 0 then
        s = ""
        Loop vmResultString through vmResultStringList
            s = s + vmResultString.s + Chr(10)
        EndLoop
        Vm_ClearMessages()
        MessageBox(s, "Vm Errors")
        exit
    Endif
   
    CloseScreen()

End 

Begin
    Main()
End